package necessary;

import com.google.protobuf.ByteString;
import meerkat.protobuf.Crypto;

import java.math.BigInteger;

/**
 * Created by Tzlil on 12/14/2015.
 */
public class GroupImpl implements Group {

    qilin.primitives.Group<ByteString> qilinInstance;
    public GroupImpl(qilin.primitives.Group qilinInstance) {
        this.qilinInstance = qilinInstance;
    }


    @Override
    public ByteString div(ByteString dividend, ByteString divisor) {
        return  mul(dividend,qilinInstance.negate(divisor));
    }

    @Override
    public ByteString mul(ByteString a, ByteString b) {
        return qilinInstance.add(a,b);
    }

    @Override
    public ByteString pow(ByteString bas, BigInteger exp) {
        return qilinInstance.multiply(bas,exp);
    }

    @Override
    public BigInteger groupSize() {
        return qilinInstance.orderUpperBound();
    }
}

